﻿Imports System.Reflection

Public Class cAppHelper

    Public Class StringValue
        Inherits System.Attribute

        Private c_sValue As String

        Public Sub New(svalue As String)
            c_sValue = svalue
        End Sub

        Public ReadOnly Property Value As String
            Get
                Return c_sValue
            End Get
        End Property

    End Class

    Public Shared Function GetStringValue(value As [Enum]) As String

        Dim p_sOutput As String = String.Empty
        Dim p_oType As Type
        Dim p_oFieldInfo As FieldInfo
        Dim p_oAttributes() As StringValue

        p_oType = value.GetType()
        p_oFieldInfo = p_oType.GetField(value.ToString())
        p_oAttributes = p_oFieldInfo.GetCustomAttributes(GetType(StringValue), False)

        If (p_oAttributes.Length > 0) Then
            p_sOutput = p_oAttributes(0).Value
        End If

        Return p_sOutput

    End Function

    Public Enum ApplicaitonCategory
        <StringValue("WB")>
        WisysBasics = 1
        <StringValue("AR")>
        AccountsReceivable = 2
        <StringValue("BM")>
        BillOfMaterial = 3
        <StringValue("IM")>
        Inventory = 4
        <StringValue("OE")>
        OrderEntry = 5
        <StringValue("PO")>
        PurchaseOrder = 6
        <StringValue("PP")>
        ProductionOrder = 7
        <StringValue("SF")>
        ShopFloor = 8
    End Enum

    Public Enum InventoryTransactions
        <StringValue("Receipt")>
        Receipt = 1
        <StringValue("Issue")>
        Issue = 2
        <StringValue("Transfer")>
        Transfer = 3
        <StringValue("Qty Adjustment")>
        QtyAdjustment = 4
        <StringValue("Bin Adjustment")>
        BinAdjustment = 5
    End Enum

    Public Enum DocumentSource
        <StringValue("N/A")>
        NA = 1
        <StringValue("Customer Order")>
        CustomerOrder = 2
        <StringValue("Internal")>
        Internal = 3
        <StringValue("Manufacturing")>
        Manufacturing = 4
        <StringValue("Purchase Order")>
        PurchaseOrder = 5
        <StringValue("Credit Memo")>
        CreditMemo = 6
    End Enum

    Public Enum OrderType
        <StringValue("O")>
        Order = 1
        <StringValue("C")>
        CreditMemo = 2
        <StringValue("Q")>
        Quote = 3
    End Enum

    Public Enum CostPriceOptions
        <StringValue("B")>
        Both = 1
        <StringValue("C")>
        Cost = 2
        <StringValue("N")>
        Neither = 3
        <StringValue("P")>
        Price = 4
    End Enum

End Class
