﻿Public Class frmOEOrderLine

#Region "Variables"

    Private c_oOrderEntryLine As cOrderEntryLine

#End Region

#Region "Properties"

    Public Property OeOrderLine As cOrderEntryLine
        Get
            Return c_oOrderEntryLine
        End Get
        Set(value As cOrderEntryLine)
            c_oOrderEntryLine = value
        End Set
    End Property

#End Region

#Region "Constructor"

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        c_oOrderEntryLine = New cOrderEntryLine

        dtRequestDate.Text = System.DateTime.Today
        dtPromiseDate.Text = System.DateTime.Today
        dtRequestShipDate.Text = System.DateTime.Today

        '//Set Cost and Price to -1. This uses the default iminvloc value
        txtCost.Text = "-1"
        txtPrice.Text = "-1"

    End Sub

    Public Sub New(oOrderEntryLine As cOrderEntryLine)

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        c_oOrderEntryLine = oOrderEntryLine
        LoadOrderLine()

    End Sub

#End Region

#Region "Events"

    Private Sub btnOK_Click(sender As System.Object, e As System.EventArgs) Handles btnOK.Click
        If (ValidFields() = False) Then
            Return
        End If
        Me.DialogResult = Windows.Forms.DialogResult.OK

        AddOrderLine()

    End Sub

#End Region

#Region "Private Methods"

    Private Sub LoadOrderLine()

        txtItemNo.Enabled = False

        txtItemNo.Text = c_oOrderEntryLine.ItemNo
        txtLocation.Text = c_oOrderEntryLine.Location
        txtQtyOrdered.Text = c_oOrderEntryLine.QtyOrdered.ToString
        txtQtyToShip.Text = c_oOrderEntryLine.QtyToShip.ToString
        txtPrice.Text = c_oOrderEntryLine.Price.ToString
        txtCost.Text = c_oOrderEntryLine.Cost.ToString
        dtRequestDate.Text = c_oOrderEntryLine.RequestDate.ToShortDateString
        dtPromiseDate.Text = c_oOrderEntryLine.PromiseDate.ToShortDateString
        dtRequestShipDate.Text = c_oOrderEntryLine.RequestShipDate.ToShortDateString

    End Sub

    Private Function ValidFields() As Boolean

        If (String.IsNullOrWhiteSpace(txtItemNo.Text)) Then
            MessageBox.Show("Item No Required", "OrderLine Add", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False
        End If
        If (String.IsNullOrWhiteSpace(txtLocation.Text)) Then
            MessageBox.Show("Location Required", "OrderLine Add", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False
        End If
        If (String.IsNullOrWhiteSpace(txtQtyOrdered.Text)) Then
            MessageBox.Show("Qty Ordered Required", "OrderLine Add", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False
        End If
        If (String.IsNullOrWhiteSpace(txtQtyToShip.Text)) Then
            MessageBox.Show("Qty Shipped Required", "OrderLine Add", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Return False
        End If

        Return True

    End Function

    Private Sub AddOrderLine()

        c_oOrderEntryLine.ItemNo = txtItemNo.Text
        c_oOrderEntryLine.Location = txtLocation.Text
        c_oOrderEntryLine.QtyOrdered = CDbl(txtQtyOrdered.Text)
        c_oOrderEntryLine.QtyToShip = CDbl(txtQtyToShip.Text)
        c_oOrderEntryLine.Price = If(String.IsNullOrWhiteSpace(txtPrice.Text), -1, CDbl(txtPrice.Text))
        c_oOrderEntryLine.Cost = If(String.IsNullOrWhiteSpace(txtCost.Text), -1, CDbl(txtCost.Text))
        c_oOrderEntryLine.RequestDate = dtRequestDate.Value
        c_oOrderEntryLine.PromiseDate = dtPromiseDate.Value
        c_oOrderEntryLine.RequestShipDate = dtRequestShipDate.Value

    End Sub

#End Region
    
End Class