﻿Imports System.Configuration
Imports Wisys.AllSystem

Public Class frmSettings

    Private c_oConnectionInfo As Wisys.AllSystem.ConnectionInfo

#Region "Private Methods"

    Private Sub SetWisysConnection()
        '//Set Server and Database to Wisys ConnectionInfo
        c_oConnectionInfo.Parameters(txtSQLServer.Text, txtDatabase.Text)

    End Sub

    Private Function TestWisysConnection(ByRef sWisysReturnMessage As String) As Integer
        Dim p_iWisysReturnValue As Integer = ReturnCodes.SUCCESSFUL

        Try
            p_iWisysReturnValue = c_oConnectionInfo.OpenWisysConnection(False, sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

            p_iWisysReturnValue = c_oConnectionInfo.CloseWisysConnection(TrxEnums.TransactionAction.NoTransaction, sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If


        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            p_iWisysReturnValue = ReturnCodes.FAILED

        End Try

        Return p_iWisysReturnValue

    End Function

    Private Sub SaveConnectionSettings()

        My.Settings.SQLServer = txtSQLServer.Text
        My.Settings.Database = txtDatabase.Text        
        My.Settings.Save()

    End Sub

    Private Sub DisplayConnectionSettings()

        txtSQLServer.Text = c_oConnectionInfo.Server
        txtDatabase.Text = c_oConnectionInfo.Database

    End Sub

#End Region

#Region "Constructor:"

    Public Sub New(ByRef oConnectionInfo As Wisys.AllSystem.ConnectionInfo)

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        c_oConnectionInfo = oConnectionInfo
        DisplayConnectionSettings()

    End Sub

#End Region

#Region "Events"

    Private Sub btnOK_Click(sender As System.Object, e As System.EventArgs) Handles btnOK.Click

        Dim p_iWisysReturnValue As Integer = ReturnCodes.SUCCESSFUL
        Dim p_sWisysReturnMessage As String = ""

        Try
            SetWisysConnection()
            p_iWisysReturnValue = TestWisysConnection(p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Test Connection")
            Else
                SaveConnectionSettings()
                Me.Close()
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Save Connection")
        End Try

    End Sub

    Private Sub btnCancel_Click(sender As System.Object, e As System.EventArgs) Handles btnCancel.Click
        Me.Close()
    End Sub

#End Region

 
End Class