﻿Imports System.Configuration
Imports Wisys.AllSystem
Imports Wisys.Ar

Public Class ucARCreateCustomer

#Region "Variables"

    Private c_oWisysConnection As Wisys.AllSystem.ConnectionInfo

#End Region

#Region "Constructor"
   
    Public Sub New(ByRef oConnectionInfo As Wisys.AllSystem.ConnectionInfo)

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        c_oWisysConnection = oConnectionInfo
    End Sub

#End Region

#Region "Private Methods"

    Private Function CreateCustomer(ByRef sWisysReturnMessage As String) As Integer

        Dim p_iWisysReturnValue As Integer
        Dim p_oAccountsReceivableTables As New Wisys.Ar.AccountsReceivableTables
        Dim p_sRtnCustomer As String = String.Empty

        Try

            '//Pass the Connection
            p_oAccountsReceivableTables.Connection(c_oWisysConnection)

            '//Separate objects exist for Progression and Macola ES Customer Creation
            If (c_oWisysConnection.MacolaVersion = TrxEnums.MacolaVersion.VersionES) Then
                p_iWisysReturnValue = p_oAccountsReceivableTables.CustomerES.Insert(txtCustomerNo.Text _
                                                                            , txtName.Text _
                                                                            , txtAddress1.Text _
                                                                            , txtAddress2.Text _
                                                                            , txtAddress3.Text _
                                                                            , txtZip.Text _
                                                                            , txtCity.Text _
                                                                            , txtState.Text _
                                                                            , txtCountry.Text _
                                                                            , txtESContactEmail.Text _
                                                                            , String.Empty _
                                                                            , String.Empty _
                                                                            , String.Empty _
                                                                            , 0 _
                                                                            , "001" _
                                                                            , txtPaymentMethod.Text _
                                                                            , 999999999 _
                                                                            , 0 _
                                                                            , CInt(txtSalesPerson.Text) _
                                                                            , txtCustomerType.Text _
                                                                            , txtShipVia.Text _
                                                                            , ckTaxable.Checked _
                                                                            , txtTaxCode.Text _
                                                                            , txtTaxSchedule.Text _
                                                                            , ckAllowBackOrders.Checked _
                                                                            , ckAllowPartialShipments.Checked _
                                                                            , txtLocation.Text _
                                                                            , txtESContactFirstName.Text _
                                                                            , txtESContactLastName.Text _
                                                                            , String.Empty _
                                                                            , String.Empty _
                                                                            , String.Empty _
                                                                            , String.Empty _
                                                                            , txtESContactMobilePhone.Text _
                                                                            , txtESContactEmail.Text _
                                                                            , String.Empty _
                                                                            , 0 _
                                                                            , txtTerms.Text _
                                                                            , CInt(txtCreatedByID.Text) _
                                                                            , p_sRtnCustomer _
                                                                            , sWisysReturnMessage)
            Else
                p_iWisysReturnValue = p_oAccountsReceivableTables.CustomerProgression.Insert(txtCustomerNo.Text _
                                                                                      , txtName.Text _
                                                                                      , txtAddress1.Text _
                                                                                      , txtAddress2.Text _
                                                                                      , txtZip.Text _
                                                                                      , txtCity.Text _
                                                                                      , txtState.Text _
                                                                                      , txtCountry.Text _
                                                                                      , txtESContactEmail.Text _
                                                                                      , String.Empty _
                                                                                      , String.Empty _
                                                                                      , String.Empty _
                                                                                      , 999999999 _
                                                                                      , txtSalesPerson.Text _
                                                                                      , txtCustomerType.Text _
                                                                                      , txtShipVia.Text _
                                                                                      , txtTerms.Text _
                                                                                      , ckTaxable.Checked _
                                                                                      , txtTaxCode.Text _
                                                                                      , txtTaxSchedule.Text _
                                                                                      , ckAllowBackOrders.Checked _
                                                                                      , ckAllowPartialShipments.Checked _
                                                                                      , txtLocation.Text _
                                                                                      , txtName.Text _
                                                                                      , p_sRtnCustomer _
                                                                                      , sWisysReturnMessage)
            End If

            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

            txtCustomerNo.Text = p_sRtnCustomer

        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            p_iWisysReturnValue = ReturnCodes.FAILED

        End Try

        Return p_iWisysReturnValue

    End Function

#End Region

#Region "Events"

    Private Sub btnCreateCustomer_Click(sender As System.Object, e As System.EventArgs) Handles btnCreateCustomer.Click

        Dim p_iWisysReturnValue As Integer = 0
        Dim p_sWisysReturnMessage As String = ""
        Try
            '//Start Wisys SQL Transaction
            p_iWisysReturnValue = c_oWisysConnection.OpenWisysConnection(True, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Open Connection")
                Return
            End If

            '//Create Customer
            p_iWisysReturnValue = CreateCustomer(p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Create Customer")
            End If

            '//Close Wisys Connection
            Dim p_eTransactionAction As Wisys.AllSystem.TrxEnums.TransactionAction
            p_eTransactionAction = If(p_iWisysReturnValue = SUCCESSFUL, Wisys.AllSystem.TrxEnums.TransactionAction.Commit, Wisys.AllSystem.TrxEnums.TransactionAction.Rollback)
            p_iWisysReturnValue = c_oWisysConnection.CloseWisysConnection(p_eTransactionAction, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Close Connection")
            End If


        Catch ex As Exception
            MessageBox.Show(ex.Message, "Create Customer")

        End Try

    End Sub

#End Region

End Class
