﻿Imports System.Configuration
Imports Wisys.AllSystem
Imports Wisys.ImTrx
Imports System.Collections.Generic


Public Class ucIMInventoryTransaction

#Region "Variables"

    Private c_oWisysConnection As Wisys.AllSystem.ConnectionInfo

#End Region

#Region "Constructor"

    Public Sub New(ByRef oConnectionInfo As Wisys.AllSystem.ConnectionInfo)

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        c_oWisysConnection = oConnectionInfo
        InitializeUI()

    End Sub

#End Region

#Region "Private Methods"

    Private Function ReceiptTransaction(ByRef sWisysReturnMessage As String) As Integer

        Dim p_iWisysReturnValue As Integer = ReturnCodes.SUCCESSFUL
        Dim p_oWisysBinCollection As New Wisys.AllSystem.DataStructures.ItemBins
        Dim p_oWisysSerialLotCollection As New Wisys.AllSystem.DataStructures.ItemSerialLots
        Dim p_oReceipt As New Wisys.ImTrx.Receipt

        Try
            '//Set IM Receipt Conneciton
            p_oReceipt.Connection(c_oWisysConnection)

            '//Set Properties for IM Transaction
            p_oReceipt.DocumentSource = GetSelectedDocumentSource()
            p_oReceipt.DocumentDate = dtDocumentDate.Value
            p_oReceipt.DocOrderNo = txtOrderNo.Text
            p_oReceipt.ItemNumber = txtItemNo.Text
            p_oReceipt.Location = txtLocation.Text

            '//Optional Override of Default Account
            p_oReceipt.Account_mn_no_override = txtOverrideAccountMNNo.Text
            p_oReceipt.Account_sb_no_override = txtOverrideAccountSBNo.Text
            p_oReceipt.Account_dp_no_override = txtOverrideAccountDPNo.Text

            p_oReceipt.Quantity = CDbl(txtQty.Text)
            p_oReceipt.UserName = txtUser.Text

            '//Default Cost will be used if not set
            If (Not String.IsNullOrEmpty(txtCost.Text)) Then
                p_oReceipt.Cost = CDbl(txtCost.Text)
            End If
            UcBinSerialLotGrid1.GetBinSerialLotCollection(p_oWisysBinCollection, p_oWisysSerialLotCollection)
            If (p_oWisysBinCollection IsNot Nothing AndAlso p_oWisysBinCollection.Count > 0) Then
                p_oReceipt.RecieptBins = p_oWisysBinCollection
            End If
            If (p_oWisysSerialLotCollection IsNot Nothing AndAlso p_oWisysSerialLotCollection.Count > 0) Then
                p_oReceipt.SerialLots = p_oWisysSerialLotCollection
            End If

            p_iWisysReturnValue = p_oReceipt.PostTrx(sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

            txtInventoryTransactionID.Text = p_oReceipt.InvtrxRecordID

        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            p_iWisysReturnValue = ReturnCodes.FAILED

        End Try

        Return p_iWisysReturnValue

    End Function

    Private Function IssueTransaction(ByRef sWisysReturnMessage As String) As Integer
        Dim p_iWisysReturnValue As Integer = ReturnCodes.SUCCESSFUL
        Dim p_oWisysBinCollection As New Wisys.AllSystem.DataStructures.ItemBins
        Dim p_oWisysSerialLotCollection As New Wisys.AllSystem.DataStructures.ItemSerialLots
        Dim p_oIssue As New Wisys.ImTrx.Issue

        Try
            '//Set IM Conneciton
            p_oIssue.Connection(c_oWisysConnection)

            '//Set Properties for IM Transaction
            p_oIssue.DocumentSource = GetSelectedDocumentSource()
            p_oIssue.JobNo = txtJobNo.Text
            p_oIssue.DocumentDate = dtDocumentDate.Value
            p_oIssue.DocOrderNo = txtOrderNo.Text
            p_oIssue.ItemNumber = txtItemNo.Text
            p_oIssue.Location = txtLocation.Text

            '//Optional Override of Default Account
            p_oIssue.Account_mn_no_override = txtOverrideAccountMNNo.Text
            p_oIssue.Account_sb_no_override = txtOverrideAccountSBNo.Text
            p_oIssue.Account_dp_no_override = txtOverrideAccountDPNo.Text

            p_oIssue.Quantity = CDbl(txtQty.Text)
            p_oIssue.UserName = txtUser.Text

            '//Use The Flat Bin Serial/Lot Property For Single A Bin and/or Serial/Lot 
            'p_oIssue.BinNoFlatEntryValue = "BinNoToIssue"
            'p_oIssue.SerialLotFlatEntryValue = "SerialLotNumberToIssue"


            '//Bin Serial Lot Collection
            UcBinSerialLotGrid1.GetBinSerialLotCollection(p_oWisysBinCollection, p_oWisysSerialLotCollection)
            If (p_oWisysBinCollection IsNot Nothing AndAlso p_oWisysBinCollection.Count > 0) Then
                p_oIssue.IssueBins = p_oWisysBinCollection
            End If
            If (p_oWisysSerialLotCollection IsNot Nothing AndAlso p_oWisysSerialLotCollection.Count > 0) Then
                p_oIssue.SerialLots = p_oWisysSerialLotCollection
            End If

            p_iWisysReturnValue = p_oIssue.PostTrx(sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

            txtInventoryTransactionID.Text = p_oIssue.InvtrxRecordID

        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            p_iWisysReturnValue = ReturnCodes.FAILED

        End Try

        Return p_iWisysReturnValue

    End Function

    Private Function TransferTransaction(ByRef sWisysReturnMessage As String) As Integer

        Dim p_iWisysReturnValue As Integer = ReturnCodes.SUCCESSFUL
        Dim p_oWisysBinTransferCollection As New Wisys.AllSystem.DataStructures.ItemBinsTransfer
        Dim p_oWisysSerialLotCollection As New Wisys.AllSystem.DataStructures.ItemSerialLots
        Dim p_oTransfer As New Wisys.ImTrx.Transfer

        Try
            '//Set IM Conneciton
            p_oTransfer.Connection(c_oWisysConnection)

            '//Set Properties for IM Transaction
            p_oTransfer.DocumentSource = GetSelectedDocumentSource()

            p_oTransfer.JobNo = txtJobNo.Text
            p_oTransfer.DocumentDate = dtDocumentDate.Value
            p_oTransfer.DocOrderNo = txtOrderNo.Text
            p_oTransfer.ItemNumber = txtItemNo.Text
            p_oTransfer.FromLocation = txtLocation.Text
            p_oTransfer.ToLocation = txtToLocation.Text
            p_oTransfer.Quantity = CDbl(txtQty.Text)
            p_oTransfer.UserName = txtUser.Text

            '//Bin Serial Lot Collection
            UcBinSerialLotGrid1.GetBinSerialLotTransferCollection(p_oWisysBinTransferCollection, p_oWisysSerialLotCollection)
            If (p_oWisysBinTransferCollection IsNot Nothing AndAlso p_oWisysBinTransferCollection.Count > 0) Then
                p_oTransfer.Bins = p_oWisysBinTransferCollection
            End If
            If (p_oWisysSerialLotCollection IsNot Nothing AndAlso p_oWisysSerialLotCollection.Count > 0) Then
                p_oTransfer.SerialLotNumbers = p_oWisysSerialLotCollection
            End If

            p_iWisysReturnValue = p_oTransfer.PostTrx(sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

            txtInventoryTransactionID.Text = p_oTransfer.InvtrxRecordID

        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            p_iWisysReturnValue = ReturnCodes.FAILED

        End Try

        Return p_iWisysReturnValue

    End Function

    Private Function QtyAdjustmentTransaction(ByRef sWisysReturnMessage As String) As Integer

        Dim p_iWisysReturnValue As Integer = ReturnCodes.SUCCESSFUL
        Dim p_oQtyAdjustment As New Wisys.ImTrx.QtyAdj

        Try
            '//Set IM Conneciton
            p_oQtyAdjustment.Connection(c_oWisysConnection)

            '//Set Properties for IM Transaction
            p_oQtyAdjustment.JobNo = txtJobNo.Text
            p_oQtyAdjustment.DocumentDate = dtDocumentDate.Value
            p_oQtyAdjustment.DocOrderNo = txtOrderNo.Text
            p_oQtyAdjustment.ItemNumber = txtItemNo.Text
            p_oQtyAdjustment.Location = txtLocation.Text
            p_oQtyAdjustment.Quantity = CDbl(txtQty.Text)
            p_oQtyAdjustment.UserName = txtUser.Text

            p_iWisysReturnValue = p_oQtyAdjustment.PostTrx(sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            p_iWisysReturnValue = ReturnCodes.FAILED

        End Try

        Return p_iWisysReturnValue

    End Function

    Private Function BinAdjustmentTransaction(ByRef sWisysReturnMessage As String) As Integer

        Dim p_iWisysReturnValue As Integer = ReturnCodes.SUCCESSFUL
        Dim p_oWisysBinCollection As New Wisys.AllSystem.DataStructures.ItemBins
        Dim p_oWisysSerialLotCollection As New Wisys.AllSystem.DataStructures.ItemSerialLots
        Dim p_oBinAdjustment As New Wisys.ImTrx.BinAdj

        Try
            '//Set IM Conneciton
            p_oBinAdjustment.Connection(c_oWisysConnection)

            '//Set Properties for IM Transaction
            p_oBinAdjustment.DocumentDate = dtDocumentDate.Value
            p_oBinAdjustment.DocOrderNo = txtOrderNo.Text
            p_oBinAdjustment.ItemNumber = txtItemNo.Text
            p_oBinAdjustment.Location = txtLocation.Text
            p_oBinAdjustment.Quantity = CDbl(txtQty.Text)
            p_oBinAdjustment.UserName = txtUser.Text

            '//Bin Serial Lot Collection
            UcBinSerialLotGrid1.GetBinSerialLotCollection(p_oWisysBinCollection, p_oWisysSerialLotCollection)
            If (p_oWisysBinCollection IsNot Nothing AndAlso p_oWisysBinCollection.Count > 0) Then
                p_oBinAdjustment.Bins = p_oWisysBinCollection
            End If

            p_iWisysReturnValue = p_oBinAdjustment.PostTrx(sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

            txtInventoryTransactionID.Text = p_oBinAdjustment.LastIminvtrxIdWritten

        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            Return p_iWisysReturnValue

        End Try

        Return p_iWisysReturnValue

    End Function

    Private Function GetSelectedDocumentSource() As Wisys.AllSystem.TrxEnums.DocumentSource

        Select Case cbTransactionSource.SelectedItem
            Case cAppHelper.GetStringValue(cAppHelper.DocumentSource.NA)
                Return TrxEnums.DocumentSource.NA
            Case cAppHelper.GetStringValue(cAppHelper.DocumentSource.CustomerOrder)
                Return TrxEnums.DocumentSource.CustomerOrder
            Case cAppHelper.GetStringValue(cAppHelper.DocumentSource.Internal)
                Return TrxEnums.DocumentSource.Internal
            Case cAppHelper.GetStringValue(cAppHelper.DocumentSource.Manufacturing)
                Return TrxEnums.DocumentSource.Manufacturing
            Case cAppHelper.GetStringValue(cAppHelper.DocumentSource.PurchaseOrder)
                Return TrxEnums.DocumentSource.PurchaseOrder
            Case cAppHelper.GetStringValue(cAppHelper.DocumentSource.CreditMemo)
                Return TrxEnums.DocumentSource.CreditMemo
            Case Else
                Return TrxEnums.DocumentSource.NA
        End Select

    End Function

    Private Sub InitializeUI()

        cbTransactionType.Items.Add(cAppHelper.GetStringValue(cAppHelper.InventoryTransactions.Receipt))
        cbTransactionType.Items.Add(cAppHelper.GetStringValue(cAppHelper.InventoryTransactions.Issue))
        cbTransactionType.Items.Add(cAppHelper.GetStringValue(cAppHelper.InventoryTransactions.Transfer))
        cbTransactionType.Items.Add(cAppHelper.GetStringValue(cAppHelper.InventoryTransactions.QtyAdjustment))
        cbTransactionType.Items.Add(cAppHelper.GetStringValue(cAppHelper.InventoryTransactions.BinAdjustment))

        cbTransactionSource.Items.Add(cAppHelper.GetStringValue(cAppHelper.DocumentSource.NA))
        cbTransactionSource.Items.Add(cAppHelper.GetStringValue(cAppHelper.DocumentSource.CustomerOrder))
        cbTransactionSource.Items.Add(cAppHelper.GetStringValue(cAppHelper.DocumentSource.Internal))
        cbTransactionSource.Items.Add(cAppHelper.GetStringValue(cAppHelper.DocumentSource.Manufacturing))
        cbTransactionSource.Items.Add(cAppHelper.GetStringValue(cAppHelper.DocumentSource.PurchaseOrder))
        cbTransactionSource.Items.Add(cAppHelper.GetStringValue(cAppHelper.DocumentSource.CreditMemo))

    End Sub

#End Region

#Region "Events"

    Private Sub btnPostTransaction_Click(sender As System.Object, e As System.EventArgs) Handles btnPostTransaction.Click

        Dim p_iWisysReturnValue As Integer = 0
        Dim p_sWisysReturnMessage As String = ""
        Try
            '//Start Wisys SQL Transaction
            p_iWisysReturnValue = c_oWisysConnection.OpenWisysConnection(True, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Open Connection")
                Return
            End If

            '//Process Inventory Transaction
            Select Case cbTransactionType.SelectedItem
                Case cAppHelper.GetStringValue(cAppHelper.InventoryTransactions.Receipt)
                    p_iWisysReturnValue = ReceiptTransaction(p_sWisysReturnMessage)
                Case cAppHelper.GetStringValue(cAppHelper.InventoryTransactions.Issue)
                    p_iWisysReturnValue = IssueTransaction(p_sWisysReturnMessage)
                Case cAppHelper.GetStringValue(cAppHelper.InventoryTransactions.Transfer)
                    p_iWisysReturnValue = TransferTransaction(p_sWisysReturnMessage)
                Case cAppHelper.GetStringValue(cAppHelper.InventoryTransactions.BinAdjustment)
                    p_iWisysReturnValue = BinAdjustmentTransaction(p_sWisysReturnMessage)
                Case Else
                    p_sWisysReturnMessage = "Unknown Transaction Type"
                    p_iWisysReturnValue = ReturnCodes.FAILED
            End Select

            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Inventory Transaction")
            End If

            '//Close Wisys Connection
            Dim p_eTransactionAction As Wisys.AllSystem.TrxEnums.TransactionAction
            p_eTransactionAction = If(p_iWisysReturnValue = SUCCESSFUL, Wisys.AllSystem.TrxEnums.TransactionAction.Commit, Wisys.AllSystem.TrxEnums.TransactionAction.Rollback)
            p_iWisysReturnValue = c_oWisysConnection.CloseWisysConnection(p_eTransactionAction, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Close Connection")
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Inventory Transaction")

        End Try

    End Sub

#End Region

End Class
