﻿Imports Wisys.AllSystem
Imports Wisys.Im

Public Class ucIMItemMaintenance

#Region "Variables"

    Private c_oWisysConnection As Wisys.AllSystem.ConnectionInfo
    Private c_oInventoryTables As Wisys.Im.InventoryTables

#End Region

#Region "Constructor"

    Public Sub New(ByRef oConnectionInfo As Wisys.AllSystem.ConnectionInfo)

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.

        c_oWisysConnection = oConnectionInfo
        c_oInventoryTables = New Wisys.Im.InventoryTables()
        c_oInventoryTables.Connection(c_oWisysConnection)

    End Sub

#End Region

#Region "Events"

    Private Sub btnCreateItemBasic_Click(sender As System.Object, e As System.EventArgs) Handles btnCreateItemBasic.Click

        Dim p_iWisysReturnValue As Integer = 0
        Dim p_sWisysReturnMessage As String = ""
        Try
            '//Start Wisys SQL Transaction
            p_iWisysReturnValue = c_oWisysConnection.OpenWisysConnection(True, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Open Connection")
                Return
            End If

            '//Create Basic Item
            p_iWisysReturnValue = CreateItemBasic(p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Create Item")
            End If

            '//Close Wisys Connection
            Dim p_eTransactionAction As Wisys.AllSystem.TrxEnums.TransactionAction
            p_eTransactionAction = If(p_iWisysReturnValue = SUCCESSFUL, Wisys.AllSystem.TrxEnums.TransactionAction.Commit, Wisys.AllSystem.TrxEnums.TransactionAction.Rollback)
            p_iWisysReturnValue = c_oWisysConnection.CloseWisysConnection(p_eTransactionAction, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Close Connection")
            End If


        Catch ex As Exception
            MessageBox.Show(ex.Message, "Create Item")

        End Try


    End Sub

    Private Sub btnCreateItem_Click(sender As System.Object, e As System.EventArgs) Handles btnCreateItem.Click

        Dim p_iWisysReturnValue As Integer = 0
        Dim p_sWisysReturnMessage As String = ""
        Try
            '//Start Wisys SQL Transaction
            p_iWisysReturnValue = c_oWisysConnection.OpenWisysConnection(True, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Open Connection")
                Return
            End If

            '//Create Item
            p_iWisysReturnValue = CreateItem(p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Create Item")
            End If

            '//Close Wisys Connection
            Dim p_eTransactionAction As Wisys.AllSystem.TrxEnums.TransactionAction
            p_eTransactionAction = If(p_iWisysReturnValue = SUCCESSFUL, Wisys.AllSystem.TrxEnums.TransactionAction.Commit, Wisys.AllSystem.TrxEnums.TransactionAction.Rollback)
            p_iWisysReturnValue = c_oWisysConnection.CloseWisysConnection(p_eTransactionAction, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Close Connection")
            End If


        Catch ex As Exception
            MessageBox.Show(ex.Message, "Create Item")

        End Try

    End Sub

    Private Sub btnCreateItemAndLocation_Click(sender As System.Object, e As System.EventArgs) Handles btnCreateItemAndLocation.Click

        Dim p_iWisysReturnValue As Integer = 0
        Dim p_sWisysReturnMessage As String = ""
        Try
            '//Start Wisys SQL Transaction
            p_iWisysReturnValue = c_oWisysConnection.OpenWisysConnection(True, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Open Connection")
                Return
            End If

            '//Create Item Location
            p_iWisysReturnValue = CreateItemAndLocation(p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Create Item Location")
            End If

            '//Close Wisys Connection
            Dim p_eTransactionAction As Wisys.AllSystem.TrxEnums.TransactionAction
            p_eTransactionAction = If(p_iWisysReturnValue = SUCCESSFUL, Wisys.AllSystem.TrxEnums.TransactionAction.Commit, Wisys.AllSystem.TrxEnums.TransactionAction.Rollback)
            p_iWisysReturnValue = c_oWisysConnection.CloseWisysConnection(p_eTransactionAction, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Close Connection")
            End If


        Catch ex As Exception
            MessageBox.Show(ex.Message, "Create Item Location")

        End Try


    End Sub

    Private Sub btnReadItem_Click(sender As System.Object, e As System.EventArgs) Handles btnReadItem.Click

        Dim p_iWisysReturnValue As Integer = 0
        Dim p_sWisysReturnMessage As String = ""
        Try
            '//Open Wisys Connection
            p_iWisysReturnValue = c_oWisysConnection.OpenWisysConnection(False, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Open Connection")
                Return
            End If

            '//Read Item
            p_iWisysReturnValue = ReadItem(False, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Read Item")
            End If

            '//Close Wisys Connection
            p_iWisysReturnValue = c_oWisysConnection.CloseWisysConnection(TrxEnums.TransactionAction.NoTransaction, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Close Connection")
            End If

        Catch ex As Exception
            MessageBox.Show(ex.Message, "Read Item")

        End Try

    End Sub

    Private Sub btnReadItemLocation_Click(sender As System.Object, e As System.EventArgs) Handles btnReadItemLocation.Click

        Dim p_iWisysReturnValue As Integer = 0
        Dim p_sWisysReturnMessage As String = ""
        Try
            '//Start Wisys SQL Transaction
            p_iWisysReturnValue = c_oWisysConnection.OpenWisysConnection(True, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Open Connection")
                Return
            End If

            '//Read Item Location
            p_iWisysReturnValue = ReadItem(True, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Read Item Location")
            End If

            '//Close Wisys Connection
            Dim p_eTransactionAction As Wisys.AllSystem.TrxEnums.TransactionAction
            p_eTransactionAction = If(p_iWisysReturnValue = SUCCESSFUL, Wisys.AllSystem.TrxEnums.TransactionAction.Commit, Wisys.AllSystem.TrxEnums.TransactionAction.Rollback)
            p_iWisysReturnValue = c_oWisysConnection.CloseWisysConnection(p_eTransactionAction, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Close Connection")
            End If


        Catch ex As Exception
            MessageBox.Show(ex.Message, "Read Item Location")

        End Try

    End Sub

    Private Sub btnUpdateItem_Click(sender As System.Object, e As System.EventArgs) Handles btnUpdateItem.Click

        Dim p_iWisysReturnValue As Integer = 0
        Dim p_sWisysReturnMessage As String = ""
        Try
            '//Start Wisys SQL Transaction
            p_iWisysReturnValue = c_oWisysConnection.OpenWisysConnection(True, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Open Connection")
                Return
            End If

            '//Update Item
            p_iWisysReturnValue = UpdateItem(p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Update Item")
            End If

            '//Close Wisys Connection
            Dim p_eTransactionAction As Wisys.AllSystem.TrxEnums.TransactionAction
            p_eTransactionAction = If(p_iWisysReturnValue = SUCCESSFUL, Wisys.AllSystem.TrxEnums.TransactionAction.Commit, Wisys.AllSystem.TrxEnums.TransactionAction.Rollback)
            p_iWisysReturnValue = c_oWisysConnection.CloseWisysConnection(p_eTransactionAction, p_sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                MessageBox.Show(p_sWisysReturnMessage, "Close Connection")
            End If


        Catch ex As Exception
            MessageBox.Show(ex.Message, "Update Item")

        End Try

    End Sub

#End Region

#Region "Private Methods"
    ''' <summary>
    ''' This Imitmidx.Insert Overload creates an IMITMIDX record with the minimum required values assigned as parameters.  
    '''     Optional values can be assigned through the object properties 
    ''' </summary>
    ''' <remarks></remarks>
    Private Function CreateItemBasic(ByRef sWisysReturnMessage As String) As Integer

        Dim p_iWisysReturnValue As Integer = 0

        Try

            '//Pass the Connection
            c_oInventoryTables.Connection(c_oWisysConnection)

            '//Override defaults by assigning optional properties
            c_oInventoryTables.Imitmidx.Loc = txtPrimaryLocation.Text
            c_oInventoryTables.Imitmidx.Ser_lot_fg = txtSerialLotFlag.Text

            p_iWisysReturnValue = c_oInventoryTables.Imitmidx.Insert(txtItemNo.Text _
                                                                   , txtDescription1.Text _
                                                                   , txtPrimaryLocation.Text _
                                                                   , txtMaterialCostType.Text _
                                                                   , txtProductCategory.Text _
                                                                   , True _
                                                                   , sWisysReturnMessage)

            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            p_iWisysReturnValue = ReturnCodes.FAILED

        End Try

        Return p_iWisysReturnValue

    End Function
    ''' <summary>
    ''' This Imitmidx.Insert Overload creates an IMITMIDX record. 
    '''     Required and optional values are assigned through the object properties
    ''' </summary>
    ''' <remarks></remarks>
    Private Function CreateItem(ByRef sWisysReturnMessage As String) As Integer

        Dim p_iWisysReturnValue As Integer = 0

        Try

            '//Pass the Connection
            c_oInventoryTables.Connection(c_oWisysConnection)

            '//Assign Properties - Defaults will be used for non-required values 
            c_oInventoryTables.Imitmidx.Item_no = txtItemNo.Text
            c_oInventoryTables.Imitmidx.Item_desc_1 = txtDescription1.Text
            c_oInventoryTables.Imitmidx.Item_desc_2 = txtDescription2.Text
            c_oInventoryTables.Imitmidx.Loc = txtPrimaryLocation.Text
            c_oInventoryTables.Imitmidx.Mat_cost_type = txtMaterialCostType.Text
            c_oInventoryTables.Imitmidx.Prod_cat = txtProductCategory.Text
            c_oInventoryTables.Imitmidx.Activity_cd = txtItemCategory.Text
            If (c_oWisysConnection.MacolaVersion = TrxEnums.MacolaVersion.VersionES) Then
                c_oInventoryTables.Imitmidx.Byr_plnrES = CInt(txtBuyerPlanner.Text)
            Else
                c_oInventoryTables.Imitmidx.Byr_plnrProg = txtBuyerPlanner.Text
            End If
            c_oInventoryTables.Imitmidx.Mfg_method = txtMfgMethod.Text
            c_oInventoryTables.Imitmidx.Activity_cd = "A"
            c_oInventoryTables.Imitmidx.Activity_dt = DateAdd(DateInterval.Day, -1, DateTime.Now)

            c_oInventoryTables.Imitmidx.Stocked_fg = If(ckStocked.Checked, "Y", "N")
            c_oInventoryTables.Imitmidx.Controlled_fg = If(ckControlled.Checked, "Y", "N")
            c_oInventoryTables.Imitmidx.Bkord_fg = If(ckBackorderable.Checked, "Y", "N")
            c_oInventoryTables.Imitmidx.Tax_fg = If(ckTaxable.Checked, "Y", "N")

            c_oInventoryTables.Imitmidx.Mfg_method = txtMfgMethod.Text
            c_oInventoryTables.Imitmidx.Forced_demand = txtForceDemand.Text

            c_oInventoryTables.Imitmidx.Ser_lot_fg = txtSerialLotFlag.Text
            c_oInventoryTables.Imitmidx.Uom = txtUnitOfMeasure.Text


            p_iWisysReturnValue = c_oInventoryTables.Imitmidx.Insert(True, sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            p_iWisysReturnValue = ReturnCodes.FAILED

        End Try

        Return p_iWisysReturnValue

    End Function
    ''' <summary>
    ''' This Imitmidx.Insert Overload creates an IMITMIDX and IMINVLOC record. 
    '''     Required values are included as method parameters.  
    '''
    ''' *** All other properties (IMITMIDX and IMINVLOC) are defaulted and cannot be directly assigned ****
    ''' 
    ''' </summary>
    ''' <remarks></remarks>
    Private Function CreateItemAndLocation(ByRef sWisysReturnMessage As String) As Integer

        Dim p_iWisysReturnValue As Integer = 0

        Try

            '//Pass the Connection
            c_oInventoryTables.Connection(c_oWisysConnection)

            Dim p_iBuyerPlannerMacolaES As Integer = 0
            Dim p_sBuyerPlannerProgression As String = String.Empty

            If (c_oWisysConnection.MacolaVersion = TrxEnums.MacolaVersion.VersionES) Then
                p_iBuyerPlannerMacolaES = CInt(txtBuyerPlanner.Text)
            Else
                p_sBuyerPlannerProgression = txtBuyerPlanner.Text
            End If

            p_iWisysReturnValue = c_oInventoryTables.Imitmidx.Insert(txtItemNo.Text _
                                                                  , txtDescription1.Text _
                                                                  , txtDescription2.Text _
                                                                  , txtProductCategory.Text _
                                                                  , txtPrimaryLocation.Text _
                                                                  , txtUnitOfMeasure.Text _
                                                                  , ckBackorderable.Checked _
                                                                  , ckTaxable.Checked _
                                                                  , txtMaterialCostType.Text _
                                                                  , dtActivityDate.Value _
                                                                  , txtItemCategory.Text _
                                                                  , p_iBuyerPlannerMacolaES _
                                                                  , p_sBuyerPlannerProgression _
                                                                  , txtSerialLotFlag.Text _
                                                                  , ckMultiBin.Checked _
                                                                  , CDbl(txtPrice.Text) _
                                                                  , CDbl(txtAverageCost.Text) _
                                                                  , CDbl(txtLastCost.Text) _
                                                                  , CDbl(txtStandardCost.Text) _
                                                                  , txtInventoryClass.Text _
                                                                  , txtPickingSequence.Text _
                                                                  , txtMfgMethod.Text _
                                                                  , txtForceDemand.Text _
                                                                  , sWisysReturnMessage)

            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            p_iWisysReturnValue = ReturnCodes.FAILED

        End Try

        Return p_iWisysReturnValue

    End Function
    ''' <summary>
    ''' Example of Reading the Imitmidx and optionally including 
    '''    the iminvloc
    ''' </summary>
    ''' <param name="bIncludeInventoryLocaiton"></param>
    ''' <remarks></remarks>
    Private Function ReadItem(bIncludeInventoryLocaiton As Boolean, ByRef sWisysReturnMessage As String) As Integer

        Dim p_iWisysReturnValue As Integer = 0
        Dim p_bRecordFound As Boolean = False

        Try

            '//Pass the Connection
            c_oInventoryTables.Connection(c_oWisysConnection)

            If (bIncludeInventoryLocaiton) Then
                '//This InventoryTables.Imitmidx.Read overload will populate the imitmidx and the corresponding iminvloc object
                p_iWisysReturnValue = c_oInventoryTables.Imitmidx.Read(txtItemNo.Text, txtPrimaryLocation.Text, False, p_bRecordFound, sWisysReturnMessage)
            Else
                '//This InventoryTables.Imitmidx.Read overload will populate the imitmidx object
                p_iWisysReturnValue = c_oInventoryTables.Imitmidx.Read(txtItemNo.Text, False, p_bRecordFound, sWisysReturnMessage)
            End If

            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

            If (p_bRecordFound) Then
                DisplayItemInformation(c_oInventoryTables)
            End If

        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            p_iWisysReturnValue = ReturnCodes.FAILED

        End Try

        Return p_iWisysReturnValue

    End Function

    ''' <summary>
    ''' Example of Updating an item in the Imitmidx_sql table
    ''' </summary>
    ''' <remarks></remarks>
    Private Function UpdateItem(ByRef sWisysReturnMessage As String) As Integer

        Dim p_iWisysReturnValue As Integer = 0
        Dim p_iRecordsUpdated As Integer = 0

        Try

            '//Pass the Connection
            c_oInventoryTables.Connection(c_oWisysConnection)

            '//Assign Properties 
            c_oInventoryTables.Imitmidx.Item_no = txtItemNo.Text
            c_oInventoryTables.Imitmidx.Item_desc_1 = txtDescription1.Text
            c_oInventoryTables.Imitmidx.Item_desc_2 = txtDescription2.Text
            c_oInventoryTables.Imitmidx.Loc = txtPrimaryLocation.Text
            c_oInventoryTables.Imitmidx.Mat_cost_type = txtMaterialCostType.Text
            c_oInventoryTables.Imitmidx.Prod_cat = txtProductCategory.Text
            c_oInventoryTables.Imitmidx.Activity_cd = txtItemCategory.Text
            If (c_oWisysConnection.MacolaVersion = TrxEnums.MacolaVersion.VersionES) Then
                c_oInventoryTables.Imitmidx.Byr_plnrES = CInt(txtBuyerPlanner.Text)
            Else
                c_oInventoryTables.Imitmidx.Byr_plnrProg = txtBuyerPlanner.Text
            End If
            c_oInventoryTables.Imitmidx.Mfg_method = txtMfgMethod.Text
            c_oInventoryTables.Imitmidx.Activity_cd = "A"
            c_oInventoryTables.Imitmidx.Activity_dt = DateAdd(DateInterval.Day, -1, DateTime.Now)

            c_oInventoryTables.Imitmidx.Stocked_fg = If(ckStocked.Checked, "Y", "N")
            c_oInventoryTables.Imitmidx.Controlled_fg = If(ckControlled.Checked, "Y", "N")
            c_oInventoryTables.Imitmidx.Bkord_fg = If(ckBackorderable.Checked, "Y", "N")
            c_oInventoryTables.Imitmidx.Tax_fg = If(ckTaxable.Checked, "Y", "N")

            c_oInventoryTables.Imitmidx.Mfg_method = txtMfgMethod.Text
            c_oInventoryTables.Imitmidx.Forced_demand = txtForceDemand.Text

            c_oInventoryTables.Imitmidx.Ser_lot_fg = txtSerialLotFlag.Text
            c_oInventoryTables.Imitmidx.Uom = txtUnitOfMeasure.Text

            p_iWisysReturnValue = c_oInventoryTables.Imitmidx.Update(True, p_iRecordsUpdated, sWisysReturnMessage)
            If (p_iWisysReturnValue <> ReturnCodes.SUCCESSFUL) Then
                Return p_iWisysReturnValue
            End If

        Catch ex As Exception
            sWisysReturnMessage = ex.Message
            p_iWisysReturnValue = ReturnCodes.FAILED

        End Try

        Return p_iWisysReturnValue

    End Function

    Private Sub DisplayItemInformation(oInventoryTables As Wisys.Im.InventoryTables)

        '//Imitmidx object
        txtItemNo.Text = oInventoryTables.Imitmidx.Item_no
        txtDescription1.Text = oInventoryTables.Imitmidx.Item_desc_1
        txtDescription2.Text = oInventoryTables.Imitmidx.Item_desc_2
        txtPrimaryLocation.Text = oInventoryTables.Imitmidx.Loc
        txtMaterialCostType.Text = oInventoryTables.Imitmidx.Mat_cost_type
        txtProductCategory.Text = oInventoryTables.Imitmidx.Prod_cat
        txtItemCategory.Text = oInventoryTables.Imitmidx.Pur_or_mfg
        If (c_oWisysConnection.MacolaVersion = TrxEnums.MacolaVersion.VersionES) Then
            txtBuyerPlanner.Text = oInventoryTables.Imitmidx.Byr_plnrES.ToString()
        Else
            txtBuyerPlanner.Text = oInventoryTables.Imitmidx.Byr_plnrProg
        End If
        dtActivityDate.Value = oInventoryTables.Imitmidx.Activity_dt
        ckStocked.Checked = If(oInventoryTables.Imitmidx.Stocked_fg.Trim.ToUpper = "Y", True, False)
        ckControlled.Checked = If(oInventoryTables.Imitmidx.Controlled_fg.Trim.ToUpper = "Y", True, False)
        ckBackorderable.Checked = If(oInventoryTables.Imitmidx.Bkord_fg.Trim.ToUpper = "Y", True, False)
        ckTaxable.Checked = If(oInventoryTables.Imitmidx.Tax_fg.Trim.ToUpper = "Y", True, False)
        txtMfgMethod.Text = oInventoryTables.Imitmidx.Mfg_method
        txtForceDemand.Text = oInventoryTables.Imitmidx.Forced_demand
        txtSerialLotFlag.Text = oInventoryTables.Imitmidx.Ser_lot_fg
        txtUnitOfMeasure.Text = oInventoryTables.Imitmidx.Uom

        '//Iminvloc object
        txtPrice.Text = oInventoryTables.Imitmidx.Iminvloc.Price.ToString
        txtAverageCost.Text = oInventoryTables.Imitmidx.Iminvloc.Avg_cost
        txtLastCost.Text = oInventoryTables.Imitmidx.Iminvloc.Last_cost
        txtStandardCost.Text = oInventoryTables.Imitmidx.Iminvloc.Std_cost
        txtInventoryClass.Text = oInventoryTables.Imitmidx.Iminvloc.Inv_class
        txtPickingSequence.Text = oInventoryTables.Imitmidx.Iminvloc.Picking_seq
        ckMultiBin.Checked = oInventoryTables.Imitmidx.Iminvloc.Binned

    End Sub

#End Region

End Class
