﻿Imports Wisys.AllSystem

Public Class ucBinSerialLotGrid

#Region "Variables"

    Private c_oGridBinSerialLotCollection As List(Of cBinSerialLot)
    Private c_oDataSource As BindingSource

#End Region

#Region "Properties"

    Public Property AddBinSerialLotButtonVisible() As Boolean
        Get
            Return btnAddBinSerialLot.Visible
        End Get
        Set(ByVal value As Boolean)
            btnAddBinSerialLot.Visible = value
        End Set
    End Property

    Public Property ButtonsVisible As Boolean
        Get
            Return btnPanel.Visible
        End Get
        Set(value As Boolean)
            btnPanel.Visible = value
        End Set
    End Property

#End Region

#Region "Constructor"

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        InitalizeGridDataSource()

    End Sub

#End Region

#Region "Public Methods"

    Public Sub GetBinSerialLotCollection(ByRef oBinColleciton As Wisys.AllSystem.DataStructures.ItemBins, ByRef oSerialLotCollection As Wisys.AllSystem.DataStructures.ItemSerialLots)

        For iRow As Integer = 0 To gridBinSerialLot.Rows.Count - 1
            Dim p_oWisysBin As Wisys.AllSystem.DataStructures.ItemBin
            Dim p_oWisysSerialLot As Wisys.AllSystem.DataStructures.ItemSerialLot

            '//Check if Bin No has been entered
            If (Not String.IsNullOrEmpty(gridBinSerialLot.Rows(iRow).Cells("BinNo").Value)) Then
                p_oWisysBin = oBinColleciton.add(gridBinSerialLot.Rows(iRow).Cells("BinNo").Value, Math.Abs(CDbl(gridBinSerialLot.Rows(iRow).Cells("Quantity").Value)))

                '//Check if Serial Lots are associated to the Bin
                If (Not String.IsNullOrEmpty(gridBinSerialLot.Rows(iRow).Cells("SerialLotNo").Value)) Then
                    p_oWisysSerialLot = p_oWisysBin.SerialLotNumbers.Add(gridBinSerialLot.Rows(iRow).Cells("SerialLotNo").Value, Math.Abs(CDbl(gridBinSerialLot.Rows(iRow).Cells("Quantity").Value)))
                    p_oWisysSerialLot.MfgSerialLotNumber = gridBinSerialLot.Rows(iRow).Cells("MFGSerialLotNo").Value
                    p_oWisysSerialLot.EffectiveDate = CDate(gridBinSerialLot.Rows(iRow).Cells("EffectiveDate").Value)
                    p_oWisysSerialLot.ExpirationDate = CDate(gridBinSerialLot.Rows(iRow).Cells("ExpirationDate").Value)
                End If
            Else
                '//Check if Serial Lots have been entered
                If (Not String.IsNullOrEmpty(gridBinSerialLot.Rows(iRow).Cells("SerialLotNo").Value)) Then
                    p_oWisysSerialLot = oSerialLotCollection.Add(gridBinSerialLot.Rows(iRow).Cells("SerialLotNo").Value, Math.Abs(CDbl(gridBinSerialLot.Rows(iRow).Cells("Quantity").Value)))
                    p_oWisysSerialLot.MfgSerialLotNumber = gridBinSerialLot.Rows(iRow).Cells("MFGSerialLotNo").Value
                    p_oWisysSerialLot.EffectiveDate = CDate(gridBinSerialLot.Rows(iRow).Cells("EffectiveDate").Value)
                    p_oWisysSerialLot.ExpirationDate = CDate(gridBinSerialLot.Rows(iRow).Cells("ExpirationDate").Value)
                End If
            End If

        Next

    End Sub

    Public Sub GetBinSerialLotTransferCollection(ByRef oBinTransferCollection As Wisys.AllSystem.DataStructures.ItemBinsTransfer, ByRef oSerialLotCollection As Wisys.AllSystem.DataStructures.ItemSerialLots)

        For iRow As Integer = 0 To gridBinSerialLot.Rows.Count - 1
            Dim p_oWisysBin As Wisys.AllSystem.DataStructures.ItemBinTransfer
            Dim p_oWisysSerialLot As Wisys.AllSystem.DataStructures.ItemSerialLot

            '//Check if Bin No has been entered
            If (Not String.IsNullOrEmpty(gridBinSerialLot.Rows(iRow).Cells("BinNo").Value)) Then
                p_oWisysBin = oBinTransferCollection.add(gridBinSerialLot.Rows(iRow).Cells("BinNo").Value, gridBinSerialLot.Rows(iRow).Cells("ToBinNo").Value, Math.Abs(CDbl(gridBinSerialLot.Rows(iRow).Cells("Quantity").Value)))

                '//Check if Serial Lots are associated to the Bin
                If (Not String.IsNullOrEmpty(gridBinSerialLot.Rows(iRow).Cells("SerialLotNo").Value)) Then
                    p_oWisysSerialLot = p_oWisysBin.SerialLotNumbers.Add(gridBinSerialLot.Rows(iRow).Cells("SerialLotNo").Value, Math.Abs(CDbl(gridBinSerialLot.Rows(iRow).Cells("Quantity").Value)))
                    p_oWisysSerialLot.MfgSerialLotNumber = gridBinSerialLot.Rows(iRow).Cells("MFGSerialLotNo").Value
                    p_oWisysSerialLot.EffectiveDate = CDate(gridBinSerialLot.Rows(iRow).Cells("EffectiveDate").Value)
                    p_oWisysSerialLot.ExpirationDate = CDate(gridBinSerialLot.Rows(iRow).Cells("ExpirationDate").Value)
                End If
            Else
                '//Check if Serial Lots have been entered
                If (Not String.IsNullOrEmpty(gridBinSerialLot.Rows(iRow).Cells("SerialLotNo").Value)) Then
                    p_oWisysSerialLot = oSerialLotCollection.Add(gridBinSerialLot.Rows(iRow).Cells("SerialLotNo").Value, Math.Abs(CDbl(gridBinSerialLot.Rows(iRow).Cells("Quantity").Value)))
                    p_oWisysSerialLot.MfgSerialLotNumber = gridBinSerialLot.Rows(iRow).Cells("MFGSerialLotNo").Value
                    p_oWisysSerialLot.EffectiveDate = CDate(gridBinSerialLot.Rows(iRow).Cells("EffectiveDate").Value)
                    p_oWisysSerialLot.ExpirationDate = CDate(gridBinSerialLot.Rows(iRow).Cells("ExpirationDate").Value)
                End If
            End If

        Next

    End Sub


#End Region

#Region "Private Methods"

    Private Sub AddBinSerialLot()

        Dim p_oDialogResult As New DialogResult

        Using fBinSerialLotAdd As New frmBinSerialLotAdd
            p_oDialogResult = fBinSerialLotAdd.ShowDialog()
            If (p_oDialogResult = DialogResult.OK) Then
                If (fBinSerialLotAdd.BinSerialLot Is Nothing) Then
                    Return
                End If
                c_oGridBinSerialLotCollection.Add(fBinSerialLotAdd.BinSerialLot)
                c_oDataSource.ResetBindings(False)
            End If
        End Using

    End Sub

    Private Sub FormatDate(oFormatting As System.Windows.Forms.DataGridViewCellFormattingEventArgs)
        If (oFormatting IsNot Nothing AndAlso oFormatting.Value IsNot Nothing) Then
            Try
                Dim dtDate As DateTime = DateTime.Parse(oFormatting.Value.ToString())
                Dim sDateString As String = dtDate.ToString("MM/dd/yyyy")
                oFormatting.Value = sDateString
                oFormatting.FormattingApplied = True

            Catch ex As FormatException
                oFormatting.FormattingApplied = False

            End Try
        End If

    End Sub

    Private Sub InitalizeGridDataSource()

        c_oGridBinSerialLotCollection = New List(Of cBinSerialLot)

        c_oDataSource = New BindingSource
        c_oDataSource.DataSource = c_oGridBinSerialLotCollection
        gridBinSerialLot.DataSource = c_oDataSource

    End Sub

#End Region

#Region "Events"

    Private Sub btnAddBinSerialLot_Click(sender As System.Object, e As System.EventArgs) Handles btnAddBinSerialLot.Click

        AddBinSerialLot()

    End Sub

    Private Sub btnClearAll_Click(sender As System.Object, e As System.EventArgs) Handles btnClearAll.Click

        InitalizeGridDataSource()
    
    End Sub

    Private Sub gridBinSerialLot_CellFormatting(sender As Object, e As System.Windows.Forms.DataGridViewCellFormattingEventArgs) Handles gridBinSerialLot.CellFormatting

        If (Me.gridBinSerialLot.Columns(e.ColumnIndex).Name = "EffectiveDate" OrElse _
            Me.gridBinSerialLot.Columns(e.ColumnIndex).Name = "ExpirationDate") Then
            FormatDate(e)
        End If

    End Sub

#End Region

End Class
