﻿Imports Wisys.AllSystem
Imports Wisys.Oe

Public Class ucOELineGrid

#Region "Variables"

    Dim c_oGridLineCollection As List(Of cOrderEntryLine)
    Dim c_oDataSource As BindingSource

#End Region

#Region "Properties"

    Public ReadOnly Property GridLineCollection As List(Of cOrderEntryLine)
        Get
            Return c_oGridLineCollection
        End Get

    End Property
#End Region

#Region "Constructor"

    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        InitalizeGridDataSource()

    End Sub

#End Region

#Region "Public Methods"

    Public Sub AddLineItems(sOrderType As String, oOrderLines As cOrderLines)

        c_oGridLineCollection = New List(Of cOrderEntryLine)
        For Each p_oOrderLine As OEORDLIN In oOrderLines
            Dim p_oGridOrderLine As New cOrderEntryLine
            p_oGridOrderLine.LineNo = p_oOrderLine.Line_no
            p_oGridOrderLine.ItemNo = p_oOrderLine.Item_no
            p_oGridOrderLine.Location = p_oOrderLine.Loc
            p_oGridOrderLine.QtyOrdered = p_oOrderLine.Qty_ordered

            If (sOrderType.Trim.ToUpper = "C") Then
                p_oGridOrderLine.QtyToShip = p_oOrderLine.Qty_return_to_stk
            Else
                p_oGridOrderLine.QtyToShip = p_oOrderLine.Qty_to_ship
            End If

            p_oGridOrderLine.Cost = p_oOrderLine.Unit_cost
            p_oGridOrderLine.Price = p_oOrderLine.Unit_price
            p_oGridOrderLine.RequestDate = p_oOrderLine.Request_dt
            p_oGridOrderLine.PromiseDate = p_oOrderLine.Promise_dt
            p_oGridOrderLine.RequestShipDate = p_oOrderLine.Req_ship_dt
            c_oGridLineCollection.Add(p_oGridOrderLine)
        Next
        c_oDataSource.DataSource = c_oGridLineCollection
        gridOrderLine.DataSource = c_oDataSource

    End Sub

#End Region

#Region "Private Methods"

    Private Sub AddLineItem()

        Dim p_oDialogResult As New DialogResult

        Using fOEOrderLine As New frmOEOrderLine
            p_oDialogResult = fOEOrderLine.ShowDialog()
            If (p_oDialogResult = DialogResult.OK) Then
                If (fOEOrderLine.OeOrderLine Is Nothing) Then
                    Return
                End If
                c_oGridLineCollection.Add(fOEOrderLine.OeOrderLine)
                c_oDataSource.ResetBindings(False)
            End If
        End Using

    End Sub

    Private Sub InitalizeGridDataSource()

        c_oGridLineCollection = New List(Of cOrderEntryLine)

        c_oDataSource = New BindingSource
        c_oDataSource.DataSource = c_oGridLineCollection
        gridOrderLine.DataSource = c_oDataSource

    End Sub

#End Region

#Region "Events"

    Private Sub btnAddLineItem_Click(sender As System.Object, e As System.EventArgs) Handles btnAddLineItem.Click
        AddLineItem()
    End Sub

    Private Sub btnClearAll_Click(sender As System.Object, e As System.EventArgs) Handles btnClearAll.Click

        InitalizeGridDataSource()

    End Sub

    Private Sub gridOrderLine_CellDoubleClick(sender As System.Object, e As System.Windows.Forms.DataGridViewCellEventArgs) Handles gridOrderLine.CellDoubleClick

        Dim p_oOEOrderLine As cOrderEntryLine
        p_oOEOrderLine = c_oGridLineCollection(e.RowIndex)

        Dim p_oDialogResult As New DialogResult

        Using fOEOrderLine As New frmOEOrderLine(p_oOEOrderLine)
            p_oDialogResult = fOEOrderLine.ShowDialog()
            If (p_oDialogResult = DialogResult.OK) Then
                If (fOEOrderLine.OeOrderLine Is Nothing) Then
                    Return
                End If
                c_oGridLineCollection.RemoveAt(e.RowIndex)
                c_oGridLineCollection.Add(fOEOrderLine.OeOrderLine)
                c_oDataSource.ResetBindings(False)
            End If
        End Using

    End Sub

#End Region


End Class
